#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <sys/time.h>
#include "world.h"



static int instr_cmp(const struct instruction *i1,
		     const struct instruction *i2)
{
	return memcmp(i1, i2, sizeof (struct instruction));
}



int main(int argc, char **argv)
{
	int changes;
	int i;
	int num_states, num_states2;
	int max_tries;
	struct instruction *is, *is2;

	if (argc != 4 || (changes = atoi(argv[3])) <= 0) {
		fprintf(stderr, "usage: %s ant1 ant2 changes\n", argv[0]);
		exit(1);
	}

	{
		struct timeval tv;
		long seed;
		if (gettimeofday(&tv, NULL) == 0) {
			seed = tv.tv_sec + tv.tv_usec;
		} else {
			seed = time(NULL);
		}
		srand(seed);
	}

	is = read_program(argv[1]);
	is2 = read_program(argv[2]);
	for (num_states = 0; is[num_states].code != 0; num_states++)
		;
	for (num_states2 = 0; is2[num_states2].code != 0; num_states2++)
		;

	max_tries = 300 * changes;
	for (i = 0; i < changes && max_tries != 0; max_tries--) {
		if (num_states == num_states2) {
			int j = rand() % num_states;
			if (instr_cmp(&is[j], &is2[j]) != 0) {
				is[j] = is2[j];
				i++;
			}
		} else {
			int j = rand() % num_states;
			int k = rand() % num_states2;
			if (instr_cmp(&is[j], &is2[k]) != 0) {
				is[j] = is2[k];
				i++;
			}
		}
	}
	if (i < changes)
		fprintf(stderr, "  only %d changes found in %d tries.\n",
			i, 300 * changes);
	if (i == 0) {
		changes = changes / 2;
		for (i = 0; i < changes; i++) {
			int j = rand() % num_states;
			random_instruction(&is[j], j, num_states);
		}
	}

	print_program(is, stdout);
	return 0;

}
